# Generated by Django 4.1.4 on 2022-12-29 20:34

import django.db.models.deletion
from django.db import migrations, models


def set_account(apps, schema_editor):
    Transaction = apps.get_model("main", "Transaction")
    Snapshot = apps.get_model("main", "Snapshot")
    Account = apps.get_model("main", "Account")
    for snapshot in Snapshot.objects.filter(account__isnull=True):
        account = Account.objects.filter(user=snapshot.user).first()
        if account is None:
            account = Account(user=snapshot.user)
            account.save()
        snapshot.account = account
        snapshot.save()
    for transaction in Transaction.objects.filter(
        account__isnull=True, snapshot__isnull=False
    ):
        transaction.account = transaction.snapshot.account
        transaction.save()


class Migration(migrations.Migration):
    atomic = False

    dependencies = [
        ("main", "0016_alter_transaction_account_alter_transaction_snapshot"),
    ]

    operations = [
        migrations.RunPython(set_account, atomic=True),
        migrations.AlterField(
            model_name="transaction",
            name="account",
            field=models.ForeignKey(
                editable=False,
                on_delete=django.db.models.deletion.CASCADE,
                to="main.account",
                verbose_name="Account",
            ),
        ),
    ]
